#include "kernel.h"
#include "task-descriptor.h"
#include "scheduler.h"
#include "error.h"

#define FOREVER while(1)

int main(int argc, char const *argv[])
{
    KernelStruct Colonel;
    TD* Active;
    Request* syscallReq; 
    int status;

    // TODO turn off interrupts so it won't mess up RedBoot stuff
    disableInterrupts();

    kernelInit(&Colonel);

    status = schedulerInit();
    if (status) return FAILURE;

    FOREVER {
        Active = getNextTaskScheduler(&Colonel);

        if (Active == NULL) break; // no tasks to run
        
        syscallReq = activate(&Colonel, Active);

        handle(&Colonel, Active, syscallReq);
    }
    return 0;
}
